/**
 * 
 */
package dbpopulator;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Map;

/**
 * @author error0
 *
 */
public class DBPopulatorHSQL {

	private static final String DB_DRIVER = "org.hsqldb.jdbcDriver";
	private static final String DB_URI = "jdbc:hsqldb:";
	private static final String DB_NAME = "db/proj5";
	private static final String DB_USER = "sa";
	private static final String DB_PASS = "";
	
	private static final int STRINGS_LENGTH = 20;
	private static final int NUM_TUPLES = 100;
	
	private Connection con = null;
	private Statement st = null;	
		
	private static final char[] ALFABETO={
		'a','b','c','d','e','f','g','h','i','j','k','l','m',
		'n','o','p','q','r','s','t','u','v','x','y','w','z',
		' ',
		};
	public static final Map<String, Integer> SCHEMA = new HashMap<String, Integer>() {
		private static final long serialVersionUID = 1L;

	{
		//	  relation	  num_attributes (exluding id field)
	    put(	"A",			6			);
	    put(	"B",			9			);
	    put(	"C",			8			);
	    put(	"D",			12			);
	    put(	"E",			11			);
	    put(	"F",			18			);
	    put(	"G",			12			);
	    put(	"H",			7			);
	    put(	"I",			12			);
	    put(	"L",			12			);
	    put(	"M",			17			);
	    put(	"N",			6			);
	    put(	"O",			16			);
	    put(	"P",			10			);
	    put(	"Q",			8			);
	    put(	"R",			16			);
	    put(	"S",			12			);
	    put(	"T",			9			);
	    put(	"U",			6			);
	    put(	"V",			9			);
	    put(	"Z",			11			);
	}};

	public static void main(String[] args) throws Exception {
		System.out.println("INIZIO CREAZIONE DB");
		DBPopulatorHSQL dbPopulator = new DBPopulatorHSQL();	
		for (String relation:SCHEMA.keySet()) {	
			dbPopulator.dropTable(relation);
			dbPopulator.createTable(relation);
			dbPopulator.populate(relation,NUM_TUPLES);
		}		
		dbPopulator.close();
		System.out.println("FINE CREAZIONE DB");
	}		

	public DBPopulatorHSQL () throws ClassNotFoundException, SQLException {
		Class.forName(DB_DRIVER);
		con = DriverManager.getConnection(DB_URI+DB_NAME,DB_USER,DB_PASS);
		st = con.createStatement();
	}
	
	private void dropTable(String relation) {
		try {
			st.executeUpdate("DROP TABLE "+relation);
		} catch (SQLException e) {
			System.out.println(e.getMessage());
		}
	}
		
	private void createTable(String relation) throws SQLException {		
		int numAttr = SCHEMA.get(relation);
		StringBuffer query = new StringBuffer("CREATE TABLE "+relation+" ( id integer NOT NULL ");
		for(int j=1; j<=numAttr; j++)
			query.append(", "+relation+""+j+" varchar NOT NULL");
		query.append(",  PRIMARY KEY  (id))");	
		st.execute(query.toString());
	}
	
	private void populate(String relation, int numTuple) throws SQLException {
		int numAttr = SCHEMA.get(relation);
		for(int i=0; i< numTuple; i++){
			StringBuffer query = new StringBuffer("INSERT INTO "+relation+" VALUES("+i);
			for(int j=1; j<=numAttr; j++)
				query.append(", '"+this.randomString()+"'");
			query.append(")");			
			st.execute(query.toString());				
		}		
	}

	private void close() throws SQLException {
		st.executeQuery("SHUTDOWN");
		if (st!=null)
			st.close();
		if (con!=null)
			con.close();		
	}
	
	private String randomString(){
		StringBuffer s=new StringBuffer();			
		long l= Math.round(Math.random()*(STRINGS_LENGTH-1)+1);		
		for (int i=0; i<l; i++){
			char c= ALFABETO[(int)Math.round(Math.random()*(ALFABETO.length-1))];
			s.append(c);
		}
		return s.toString();
	}

}
