package proj5.business.flyweight;

import java.util.HashMap;

import proj5.model.core.Leaf;
import proj5.persistence.*;
import proj5.persistence.dao.PersistenceDaoFacade;
import proj5.persistence.jpa.PersistenceJpaFacade;

public class LeafFactory {
	HashMap <String, Flyweight> flyweightObjects;
	static LeafFactory instance;
	PersistenceFacade persistenceFacade;
	boolean flyweightEnabled;

	private LeafFactory(){
		this.flyweightObjects= new HashMap <String,Flyweight>();
		this.persistenceFacade= new PersistenceJpaFacade(); //cambiare qui la facade da utilizzare
		this.flyweightEnabled=false;
	}
	
	public static LeafFactory getIstance(){
		if(instance==null)
			instance=new LeafFactory();
		return instance;
	}
	
	public void setFlyweightEnable(boolean status){
		this.flyweightEnabled=status;
	}
	
	public Leaf getLeaf(String leafType, int id){
		if (flyweightEnabled)
			return (Leaf)createFlyweightLeaf(leafType, id);
		
		return createLeaf(leafType, id);
		
	}
	
	private Flyweight createFlyweightLeaf(String leafType, int id){
		Flyweight fw=flyweightObjects.get(leafType+id);
		
		if(fw==null){
			fw=createLeaf(leafType, id);
			flyweightObjects.put(leafType+id, fw);
		}
		return fw;
	}
	
	@SuppressWarnings("unchecked")
	private Leaf createLeaf(String leafType, int id){ 
	
		Leaf leaf=null;
		try {
			Class[] args= new Class[1];
			args[0]=int.class;
			leaf=(Leaf) persistenceFacade.getClass().getMethod("trova"+leafType+"byId", args).invoke(persistenceFacade, id);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return leaf;
	}
}
