package proj5.gui;
import java.awt.event.ActionEvent;
import java.io.FileNotFoundException;
import javax.swing.AbstractAction;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.GroupLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.LayoutStyle;
import javax.swing.WindowConstants;
import javax.swing.SwingUtilities;
import proj5.Proj5Controller;
import proj5.model.core.Component;
import proj5.utils.xml.ParserXmlException;
import proj5.utils.xml.XmlNotWellFormedException;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class ProJFrame extends javax.swing.JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	{
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel("com.jgoodies.looks.plastic.PlasticXPLookAndFeel");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	private JPanel menuPanel;
	private JCheckBox flyweightCheckBox;
	private JButton buildButton;
	private AbstractAction buildTree;
	private JScrollPane resultJScrollPane;
	private JEditorPane resultJEditorPane;
	private JLabel iconErrorLabel;
	private JScrollPane errorScrollPane;
	private AbstractAction close;
	private JButton Ok;
	private JLabel errorLabel;
	private JDialog errorDialog;
	private JComboBox modelsComboBox;
	private JPanel resultPanel;
	private Proj5Controller controller= new Proj5Controller();
	private String modelsDirectory="models";
	private Component tree;
	private String errorIconPath="images/error.gif";
	
	
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				ProJFrame inst = new ProJFrame();
				GroupLayout instLayout = new GroupLayout((JComponent)inst.getContentPane());
				instLayout.setLayoutStyle(null);
				inst.getContentPane().setLayout(instLayout);
				inst.setLocationRelativeTo(null);
				inst.setVisible(true);
			}
		});
	}
	
	public ProJFrame() {
		super();
		initGUI();
	}
	
	private void initGUI() {
		try {
			GroupLayout thisLayout = new GroupLayout((JComponent)getContentPane());
			getContentPane().setLayout(thisLayout);
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			{
				menuPanel = new JPanel();
				GroupLayout jPanel1Layout = new GroupLayout((JComponent)menuPanel);
				menuPanel.setLayout(jPanel1Layout);
				{
					ComboBoxModel jComboBox1Model = 
						new DefaultComboBoxModel(controller.listXmlFiles(modelsDirectory).toArray());
					modelsComboBox = new JComboBox();
					modelsComboBox.setModel(jComboBox1Model);
				}
				{
					flyweightCheckBox = new JCheckBox();
					flyweightCheckBox.setText("Flyweight on");
				}
				{
					buildButton = new JButton();
					buildButton.setText("Build");
					buildButton.setMnemonic(java.awt.event.KeyEvent.VK_G);
					buildButton.setAction(getBuildTree());
				}
				jPanel1Layout.setHorizontalGroup(jPanel1Layout.createSequentialGroup()
					.addGap(7)
					.addComponent(modelsComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE)
					.addGap(32)
					.addComponent(flyweightCheckBox, GroupLayout.PREFERRED_SIZE, 110, GroupLayout.PREFERRED_SIZE)
					.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
					.addComponent(buildButton, GroupLayout.PREFERRED_SIZE, 93, GroupLayout.PREFERRED_SIZE)
					.addContainerGap(201, 201));
				jPanel1Layout.setVerticalGroup(jPanel1Layout.createSequentialGroup()
					.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
					.addGroup(jPanel1Layout.createParallelGroup()
					    .addGroup(GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
					        .addGap(0, 0, Short.MAX_VALUE)
					        .addComponent(buildButton, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE))
					    .addGroup(jPanel1Layout.createSequentialGroup()
					        .addGap(0, 0, Short.MAX_VALUE)
					        .addComponent(modelsComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE))
					    .addGroup(GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
					        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 0, Short.MAX_VALUE)
					        .addComponent(flyweightCheckBox, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE)
					        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)))
					.addGap(8));
			}
			{
				resultPanel = new JPanel();
				GroupLayout jPanel2Layout = new GroupLayout((JComponent)resultPanel);
				resultPanel.setLayout(jPanel2Layout);
				jPanel2Layout.setHorizontalGroup(jPanel2Layout.createSequentialGroup()
					.addGap(7)
					.addComponent(getResultJScrollPane(), 0, 473, Short.MAX_VALUE));
				jPanel2Layout.setVerticalGroup(jPanel2Layout.createSequentialGroup()
					.addComponent(getResultJScrollPane(), GroupLayout.PREFERRED_SIZE, 159, GroupLayout.PREFERRED_SIZE)
					.addContainerGap());
			}
				thisLayout.setVerticalGroup(thisLayout.createSequentialGroup()
					.addComponent(menuPanel, GroupLayout.PREFERRED_SIZE, 38, GroupLayout.PREFERRED_SIZE)
					.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
					.addComponent(resultPanel, GroupLayout.PREFERRED_SIZE, 171, GroupLayout.PREFERRED_SIZE));
				thisLayout.setHorizontalGroup(thisLayout.createSequentialGroup()
					.addGroup(thisLayout.createParallelGroup()
					    .addComponent(menuPanel, GroupLayout.Alignment.LEADING, GroupLayout.PREFERRED_SIZE, 480, GroupLayout.PREFERRED_SIZE)
					    .addComponent(resultPanel, GroupLayout.Alignment.LEADING, GroupLayout.PREFERRED_SIZE, 480, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED));
			pack();
			this.setSize(495, 245);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private AbstractAction getBuildTree() {
		if(buildTree == null) {
			buildTree = new AbstractAction("Build", null) {
				/**
				 * 
				 */
				private static final long serialVersionUID = 1L;

				public void actionPerformed(ActionEvent evt) {
					boolean flyweightEnabled=flyweightCheckBox.isSelected();
					String model=modelsComboBox.getSelectedItem().toString();
					
					try {
						tree=controller.buildTree(modelsDirectory+System.getProperty("file.separator")+model, flyweightEnabled);
					} catch (FileNotFoundException e) {
						getErrorDialog().pack();
						getErrorDialog().setLocationRelativeTo(null);
						getErrorDialog().setVisible(true);
						errorLabel.setText(e.toString());
						
						e.printStackTrace();
					} catch (ParserXmlException e) {
						getErrorDialog().pack();
						getErrorDialog().setLocationRelativeTo(null);
						getErrorDialog().setVisible(true);
						errorLabel.setText(e.toString());
						
						e.printStackTrace();
					} catch (XmlNotWellFormedException e) {
						getErrorDialog().pack();
						getErrorDialog().setLocationRelativeTo(null);
						getErrorDialog().setVisible(true);
						errorLabel.setText(e.toString());
						
						e.printStackTrace();
					}
					resultJEditorPane.setText(""+tree.operationPrint(0));
					
				}
			};
		}
		return buildTree;
	}

	private JDialog getErrorDialog() {
		if(errorDialog == null) {
			errorDialog = new JDialog(this);
			GroupLayout jDialog1Layout = new GroupLayout((JComponent)errorDialog.getContentPane());
			errorDialog.getContentPane().setLayout(jDialog1Layout);
			errorDialog.setTitle("Error");
			errorDialog.setSize(579, 297);
			jDialog1Layout.setHorizontalGroup(jDialog1Layout.createSequentialGroup()
				.addContainerGap()
				.addComponent(getIconErrorLabel(), GroupLayout.PREFERRED_SIZE, 91, GroupLayout.PREFERRED_SIZE)
				.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
				.addGroup(jDialog1Layout.createParallelGroup()
				    .addComponent(getErrorScrollPane(), GroupLayout.Alignment.LEADING, GroupLayout.PREFERRED_SIZE, 439, GroupLayout.PREFERRED_SIZE)
				    .addGroup(GroupLayout.Alignment.LEADING, jDialog1Layout.createSequentialGroup()
				        .addGap(349)
				        .addComponent(getOk(), GroupLayout.PREFERRED_SIZE, 90, GroupLayout.PREFERRED_SIZE)))
				.addContainerGap(15, 15));
			jDialog1Layout.setVerticalGroup(jDialog1Layout.createSequentialGroup()
				.addGroup(jDialog1Layout.createParallelGroup()
				    .addComponent(getErrorScrollPane(), GroupLayout.Alignment.LEADING, GroupLayout.PREFERRED_SIZE, 205, GroupLayout.PREFERRED_SIZE)
				    .addGroup(GroupLayout.Alignment.LEADING, jDialog1Layout.createSequentialGroup()
				        .addGap(23)
				        .addComponent(getIconErrorLabel(), GroupLayout.PREFERRED_SIZE, 88, GroupLayout.PREFERRED_SIZE)
				        .addGap(94)))
				.addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
				.addComponent(getOk(), GroupLayout.PREFERRED_SIZE, 28, GroupLayout.PREFERRED_SIZE)
				.addContainerGap(22, 22));
		}
		return errorDialog;
	}
	
	private JLabel getErrorLabel() {
		if(errorLabel == null) {
			errorLabel = new JLabel();
			GroupLayout errorLabelLayout = new GroupLayout((JComponent)errorLabel);
			errorLabel.setLayout(errorLabelLayout);
			errorLabel.setAutoscrolls(true);
			errorLabel.setPreferredSize(new java.awt.Dimension(696, 196));
			errorLabelLayout.setVerticalGroup(errorLabelLayout.createParallelGroup());
			errorLabelLayout.setHorizontalGroup(errorLabelLayout.createParallelGroup());
		}
		return errorLabel;
	}
	
	private JButton getOk() {
		if(Ok == null) {
			Ok = new JButton();
			Ok.setText("Ok");
			Ok.setAction(getClose());
		}
		return Ok;
	}
	
	private AbstractAction getClose() {
		if(close == null) {
			close = new AbstractAction("Close", null) {
				public void actionPerformed(ActionEvent evt) {
					getErrorDialog().dispose();
				}
			};
		}
		return close;
	}
	
	private JScrollPane getErrorScrollPane() {
		if(errorScrollPane == null) {
			errorScrollPane = new JScrollPane();
			errorScrollPane.setViewportView(getErrorLabel());
		}
		return errorScrollPane;
	}
	
	private JLabel getIconErrorLabel() {
		if(iconErrorLabel == null) {
			iconErrorLabel = new JLabel();
			iconErrorLabel.setIcon(new ImageIcon(getClass().getClassLoader().getResource(errorIconPath)));
		}
		return iconErrorLabel;
	}

	private JEditorPane getResultJEditorPane() {
		if(resultJEditorPane == null) {
			resultJEditorPane = new JEditorPane();
			resultJEditorPane.setEditable(false);
			resultJEditorPane.setAutoscrolls(false);
			resultJEditorPane.setMargin(new java.awt.Insets(2, 2, 2, 2));
			resultJEditorPane.setPreferredSize(new java.awt.Dimension(439, 142));
		}
		return resultJEditorPane;
	}
	
	private JScrollPane getResultJScrollPane() {
		if(resultJScrollPane == null) {
			resultJScrollPane = new JScrollPane();
			resultJScrollPane.setViewportView(getResultJEditorPane());
		}
		return resultJScrollPane;
	}

}
