package proj5.model.core;

import java.util.Vector;

public class Composite implements Component {

	private Vector<Component> children = new Vector<Component>();

	public String operationPrint(int deep) {
		StringBuffer level = new StringBuffer();
		StringBuffer res = new StringBuffer();
		
		for(int i=0;i<deep;i++)level.append("|  ");
		
		res.append(level.toString()+"<\n");
		
		for (int i = 0; i < children.size(); ++i)
			res.append(children.elementAt(i).operationPrint(deep+1)+"\n");
		
		res.append(level.toString()+">");
		
		return res.toString();
	}

	public void add(Component component) {
		children.addElement(component);
	}

	public boolean remove(Component component) {
		return children.removeElement(component);
	}

	public Component getChild(int index) {
		return (Component) children.elementAt(index);
	}
	
	public String toString(){
		StringBuffer res = new StringBuffer("\t[");
		for (int i = 0; i < children.size(); ++i)
			res.append(children.elementAt(i)+", ");
		return res.substring(0, res.lastIndexOf(",")) +"]";
	}
}
