package proj5.persistence.dao;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.Statement;

import proj5.model.core.Leaf;
import proj5.persistence.dao.core.DataSource;

public class LeafDao {
	
	private static final String MODELS_PACKAGE="proj5.model";
	
	
	
	public Leaf find(String leafType, int id){
		
		Connection conn = null;
		Leaf leaf = null;
		
		try{
			conn = DataSource.getInstance().getConnection();	
			Statement st = conn.createStatement();
			ResultSet result = st.executeQuery("select * from "+leafType+" where id="+id);
			if (result.next()){

				DatabaseMetaData metadata = conn.getMetaData();
				ResultSet metadataResult = metadata.getColumns(null,null,leafType,null);
				
				leaf = (Leaf) Class.forName(MODELS_PACKAGE+"."+leafType).newInstance();
				
				//set id
				leaf.getClass().getMethod("setId", new Class[]{int.class}).invoke(leaf, id);
				
				//for each attribute set the value
				while(metadataResult.next()){				
					String attributeName = metadataResult.getString("COLUMN_NAME");
					if(attributeName.equals("id") || attributeName.equals("ID")) continue;
					
					String methodName = "set" + attributeName;
					String attrValue = result.getString(attributeName);
					
					leaf.getClass().getMethod(methodName, new Class[]{String.class}).invoke(leaf, attrValue);
				}				
			}
			return leaf;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		} finally {
			DataSource.getInstance().close(conn);
		}
	}
}
