/**
 * 
 */
package proj5.persistence.jpa.service.core;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

/**
 * @author Valerio Barbagallo
 *
 */
public abstract class BaseService {
	
	private EntityManagerFactory emf;

	protected BaseService(){
		emf = EntityManagerFactoryHandler.getHandler().getEntityManagerFactory();
	}
	
	protected EntityManager getTransactionalEntityManager() {
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        return em;        
    }
    protected void closeTransactionalEntityManager(EntityManager em) {
       	em.getTransaction().commit();
        em.close();
    }
    protected EntityManager getEntityManager() {
        return emf.createEntityManager();
    }
    protected void closeEntityManager(EntityManager em) {
        em.close();
    }

}
